// Package jira provides an adapter for interacting with Jira.
// It facilitates operations such as creating plans.
package jira

import (
	"context"
	"log"
	"strings"
	"unicode"

	v3 "github.com/ctreminiom/go-atlassian/jira/v3"
	"github.com/ctreminiom/go-atlassian/pkg/infra/models"
	"gitlab.com/david.dlouhy1/oasis/internal/domain"
)

// Adapter represents the Jira adapter.
type Adapter struct {
	client             *v3.Client // Jira client instance.
	defaultTemplate    string     // Default project template.
	defaultDescription string     // Default project description.
}

// NewAdapter creates a new Jira adapter with the provided credentials.
func NewAdapter(token string, url string, mail string) (*Adapter, error) {
	client, err := v3.New(nil, url)
	if err != nil {
		log.Fatal(err)
	}
	client.Auth.SetBasicAuth(mail, token)

	return &Adapter{
		client:             client,
		defaultTemplate:    "com.pyxis.greenhopper.jira:gh-simplified-agility-kanban",
		defaultDescription: "Generated by OASIS",
	}, nil
}

// CreatePlan creates a new Jira plan with the specified name.
func (adapter *Adapter) CreatePlan(name string) (project *domain.Plan, err error) {

	project = &domain.Plan{}

	currentUser, _, err := adapter.client.MySelf.Details(context.Background(), nil)
	if err != nil {
		log.Fatal(err)
	}

	projectKey := strings.Map(func(r rune) rune {
		if unicode.IsLetter(r) || unicode.IsDigit(r) {
			return unicode.ToUpper(r)
		}
		return -1
	}, name)

	if len(projectKey) > 10 {
		projectKey = projectKey[:5] + projectKey[len(projectKey)-5:]
	}

	payload := &models.ProjectPayloadScheme{
		Description:        adapter.defaultDescription,
		LeadAccountID:      currentUser.AccountID,
		ProjectTemplateKey: adapter.defaultTemplate,
		Name:               name,
		Key:                projectKey,
	}

	_, _, err = adapter.client.Project.Create(context.Background(), payload)
	if err != nil {
		project, _, _ := adapter.client.Project.Get(context.Background(), projectKey, nil)
		if project != nil {
			err = nil
		}

	}

	return
}
